var adPlugin = null;

function stopCurrentAdSlot() {
    if(adPlugin){
        adPlugin.stopAdSlot();
    }
}

function skipCurrentAd() {
    if(adPlugin){
        adPlugin.skipAd();
    }
}

function clickThroughURL() {
    if(adPlugin){
        return adPlugin.clickThrough(true);
    }

    return "";
}

function hasClickThrough() {
    return adPlugin && adPlugin.hasClickThrough;
}

function getAdVerification() {
    return adPlugin.ad.verifications;
}

function getAdInfo() {
    return JSON.stringify(adPlugin.ad.info);
}

function getAdError() {
    return JSON.stringify(adPlugin.ad.error);
}

function getPublicAdSlot() {
    return JSON.stringify(adPlugin.adSlot);
}

function playAdWithURL(adURL, openerURL, forceOpener, closerURL, forceCloser, bumperURL, forceBumper, environmentVarsJSON, skipOffset) {
    console.log("playAdWithURL(" + adURL + ", " + openerURL + ", " + closerURL + ", " + bumperURL + ", " + environmentVarsJSON + ", "+ skipOffset + ")");
    var skipOffsetInt = parseInt(skipOffset);
    if (skipOffsetInt > 0) {
        globalAdConfig.skipOffset = skipOffsetInt;
    }
    var connectResult = smartclientcore.connect(playerProxy);
    if (connectResult) {
        connectResult.setup(globalAdConfig).then(api => {
                                                 adPlugin = api;

                                                 /**
                                                  * You are ready to request your first ads
                                                  * this is also a good point to subscribe to ad events
                                                  */
                                                 smartclientcore.EVENTS.forEach(eventType => {
                                                                                adPlugin.addEventListener(eventType, (event) => {
                                                                                                          playerProxy.onEventCallback(JSON.stringify(event));
                                                                                                          });
                                                                                });

                                                 var config = {
                                                 tag: adURL
                                                 };
                                                 if (openerURL != "null") {
                                                 config.opener = {
                                                 progressive: openerURL,
                                                 forcePlay: forceOpener
                                                 }
                                                 };
                                                 if (closerURL != "null") {
                                                 config.closer = {
                                                 progressive: closerURL,
                                                 forcePlay: forceCloser
                                                 }
                                                 };
                                                 if (bumperURL != "null") {
                                                 config.bumper = {
                                                 progressive: bumperURL,
                                                 forcePlay: forceBumper
                                                 }
                                                 };
                                                 adPlugin.initAdSlot(config, JSON.parse(environmentVarsJSON)).then(function(adLoaded) {
                                                                                                                   console.log('### Loading AdManifest success.');
                                                                                                                   adPlugin.startAdSlot();
                                                                                                                   }, function(failedLoading) {
                                                                                                                   console.warn('### Loading AdManifest failed', failedLoading);
                                                                                                                   });

                                                 }, failure => {
                                                 console.log("Error: ", failure);
                                                 });
    } else {
        console.log("Error: connection error. connect returned null");
    }
}
