//
//  SCOutstreamScrollViewController.swift
//  Smartclipios-app-demo
//
//  Copyright © 2019 smartclip. All rights reserved.
//

import UIKit
import SmartclipSDKiOS

class SCOutstreamScrollViewController: SCOutstreamBaseViewController, UIScrollViewDelegate {
    @IBOutlet weak var scrollView: UIScrollView!
    @IBOutlet weak private var titleLabel: UILabel!
    @IBOutlet weak private var subTitleLabel: UILabel!
    
    @IBOutlet weak var introLabel: UILabel!
    @IBOutlet weak var outroLabel: UILabel!

    let adURL = Constants.adURL

    override func viewDidLoad() {
        super.viewDidLoad()

        self.titleLabel.text = Constants.outstreamTitle
        self.subTitleLabel.text = Constants.outstreamText
        
        self.introLabel.text = Constants.sampleText
        self.outroLabel.text = Constants.sampleText
    }

    override func startPlayback() {
        startAdSlot(with: adURL, opener: Constants.opener, closer: Constants.closer, bumper: Constants.bumper, breakPosition: SCBreakPositionStandAlone)
    }

    override func adSlotFinished() {
        super.adSlotFinished()
        contentView.invalidateIntrinsicContentSize()
    }

}
